using System;
using System.Runtime.InteropServices;
using System.Text;

namespace BlockIOSDK
{
    [StructLayout(LayoutKind.Sequential, Pack = 1)]
    public struct BLOCKIO_PASSWORD
    {
	    public bool bEnabled;
        [MarshalAs(UnmanagedType.ByValArray, SizeConst = 7)]
	    public char[] szPasswd;
    }

    public class BlockIOAPIr
    {
        [DllImport("BlockIOAPIr.dll", EntryPoint = "SYS_Install")]
        public static extern uint SYS_Install(out IntPtr oHandle, string Address);

        [DllImport("BlockIOAPIr.dll", EntryPoint = "SYS_Release")]
        public static extern uint SYS_Release(IntPtr Handle);

        [DllImport("BlockIOAPIr.dll", EntryPoint = "SYS_GetPassword")]
        public static extern uint SYS_GetPassword(IntPtr Handle, out BLOCKIO_PASSWORD ptPassword);

        [DllImport("BlockIOAPIr.dll", EntryPoint = "SYS_SetPassword")]
        public static extern uint SYS_SetPassword(IntPtr Handle, ref BLOCKIO_PASSWORD ptPassword);

        [DllImport("BlockIOAPIr.dll", EntryPoint = "SYS_ResotreCoeff")]
        public static extern uint SYS_ResotreCoeff(IntPtr Handle);

        [DllImport("BlockIOAPIr.dll", EntryPoint = "SYS_EnableWatchDog")]
        public static extern uint SYS_EnableWatchDog(IntPtr Handle);

        [DllImport("BlockIOAPIr.dll", EntryPoint = "SYS_DisableWatchDog")]
        public static extern uint SYS_DisableWatchDog(IntPtr Handle);

        [DllImport("BlockIOAPIr.dll", EntryPoint = "SYS_ResetWatchDog")]
        public static extern uint SYS_ResetWatchDog(IntPtr Handle);

        [DllImport("BlockIOAPIr.dll", EntryPoint = "SYS_GetResetStatus")]
        public static extern uint SYS_GetResetStatus(IntPtr Handle, out ushort pwVal);

        [DllImport("BlockIOAPIr.dll", EntryPoint = "SYS_GetModuleName")]
        public static extern uint SYS_GetModuleName(IntPtr Handle, StringBuilder ModuleName, int nSize);
        
        [DllImport("BlockIOAPIr.dll", EntryPoint = "SYS_GetModuleFirmware")]
        public static extern uint SYS_GetModuleFirmware(IntPtr Handle, StringBuilder FirmwareVer, int nSize);
        
        [DllImport("BlockIOAPIr.dll", EntryPoint = "SYS_GetWatchDogConfig")]
        public static extern uint SYS_GetWatchDogConfig(IntPtr Handle, out bool Enable, out double WDTimer);
        
        [DllImport("BlockIOAPIr.dll", EntryPoint = "SYS_SetWatchDogConfig")]
        public static extern uint SYS_SetWatchDogConfig(IntPtr Handle, bool Enable, double WDTimer);

        [DllImport("BlockIOAPIr.dll", EntryPoint = "SYS_ReadDiscreteModuleValues")]
        public static extern uint SYS_ReadDiscreteModuleValues(IntPtr hSession, byte byType, uint nAddr, [MarshalAs(UnmanagedType.LPArray)]byte[] pcbData, uint cbSize, uint bitCount);

        [DllImport("BlockIOAPIr.dll", EntryPoint = "SYS_ReadModuleValues")]
        public static extern uint SYS_ReadModuleValues(IntPtr hSession, byte byType, uint nAddr, [MarshalAs(UnmanagedType.LPArray)]ushort[] pcwData, uint cwSize, uint wordCount);

        [DllImport("BlockIOAPIr.dll", EntryPoint = "SYS_WriteDiscreteModuleValues")]
        public static extern uint SYS_WriteDiscreteModuleValues(IntPtr hSession, uint nAddr, [MarshalAs(UnmanagedType.LPArray)]byte[] pcbData, uint cbSize, uint bitCount, bool bBroadcast);

        [DllImport("BlockIOAPIr.dll", EntryPoint = "SYS_WriteModuleValues")]
        public static extern uint SYS_WriteModuleValues(IntPtr hSession, uint nAddr, [MarshalAs(UnmanagedType.LPArray)]ushort[] pcwData, uint cwSize, uint wordCount, bool bBroadcast);
    }
}
