using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using BlockIOSDK;

namespace BlockIO5068
{
    public partial class Form1 : Form
    {
        private IntPtr mHandle;
        public Form1()
        {
            InitializeComponent();
        }

        private void Open_Click(object sender, EventArgs e)
        {
            if (IA.Text == "")
            {
                MessageBox.Show("Please input IP address!!");
                return;
            }

            //install
            btnOpen.Enabled = false;
            uint dwRet = BlockIOAPIr.SYS_Install(out mHandle, IA.Text);
            if ((dwRet & 0xFF) != 0)
            {
                dwRet = dwRet & 0xFF;
                MessageBox.Show(String.Format("Function SYS_Install returns error code: {0}!", dwRet));
                btnOpen.Enabled = true;
                return;
            }
            btnClose.Enabled = true;
            //

            //get module's name
            StringBuilder ss = new StringBuilder(20);
            BlockIOAPIr.SYS_GetModuleName(mHandle, ss, 20);
            MN.Text = ss.ToString();
            //

            //get module's firmware version
            StringBuilder ss1 = new StringBuilder(20);
            BlockIOAPIr.SYS_GetModuleFirmware(mHandle, ss1, 20);
            FV.Text = ss1.ToString();
            //

            //get watchdog config
            bool Enable;
            double WDTimer;
            BlockIOAPIr.SYS_GetWatchDogConfig(mHandle, out Enable, out WDTimer);
            WD.Checked = Enable;
            WDT.Text = String.Format("{0}", WDTimer);
            WD.Enabled = true;
            WDT.Enabled = true;
            btnUpdate.Enabled = true;
            //

            byte[] dwDI = new byte[2];
            byte dwDO;
            BlockIO5068r.DIO_GetDIO(mHandle, dwDI, out dwDO);
            DI0.Checked = (dwDI[0] & (1 << 0)) > 0;
            DI1.Checked = (dwDI[0] & (1 << 1)) > 0;
            DI2.Checked = (dwDI[0] & (1 << 2)) > 0;
            DI3.Checked = (dwDI[0] & (1 << 3)) > 0;
            DI4.Checked = (dwDI[0] & (1 << 4)) > 0;
            DI5.Checked = (dwDI[0] & (1 << 5)) > 0;
            DI6.Checked = (dwDI[0] & (1 << 6)) > 0;
            DI7.Checked = (dwDI[0] & (1 << 7)) > 0;
            DI8.Checked = (dwDI[1] & (1 << 1)) > 0;
            DI9.Checked = (dwDI[1] & (1 << 2)) > 0;
            DI10.Checked = (dwDI[1] & (1 << 3)) > 0;
            DI11.Checked = (dwDI[1] & (1 << 4)) > 0;
            DI12.Checked = (dwDI[1] & (1 << 5)) > 0;
            DI13.Checked = (dwDI[1] & (1 << 6)) > 0;
            
            DO0.Checked = (dwDO & (1 << 0)) > 0;
            DO1.Checked = (dwDO & (1 << 1)) > 0;
            DO2.Checked = (dwDO & (1 << 2)) > 0;
            DO3.Checked = (dwDO & (1 << 3)) > 0;
            DO4.Checked = (dwDO & (1 << 4)) > 0;
            DO5.Checked = (dwDO & (1 << 5)) > 0;
            DO6.Checked = (dwDO & (1 << 6)) > 0;
            DO7.Checked = (dwDO & (1 << 7)) > 0;

            DO0.Enabled = true;
            DO1.Enabled = true;
            DO2.Enabled = true;
            DO3.Enabled = true;
            DO4.Enabled = true;
            DO5.Enabled = true;
            DO6.Enabled = true;
            DO7.Enabled = true;

            SetS.Enabled = true;
            SetP.Enabled = true;

            timer1.Enabled = true;

            btnClose.Enabled = true;
        }

        private void btnClose_Click(object sender, EventArgs e)
        {
            timer1.Enabled = false;

            btnClose.Enabled = false;

            BlockIOAPIr.SYS_Release(mHandle);

            WD.Checked = false;
            WD.Enabled = false;
            WDT.Enabled = false;
            btnUpdate.Enabled = false;
            btnOpen.Enabled = true;

            WDT.Text = "";
            MN.Text = "";
            FV.Text = "";

            DI0.Checked = false;
            DI1.Checked = false;
            DI2.Checked = false;
            DI3.Checked = false;
            DI4.Checked = false;
            DI5.Checked = false;
            DI6.Checked = false;
            DI7.Checked = false;
            DI8.Checked = false;
            DI9.Checked = false;
            DI10.Checked = false;
            DI11.Checked = false;
            DI12.Checked = false;
            DI13.Checked = false;

            DO0.Checked = false;
            DO1.Checked = false;
            DO2.Checked = false;
            DO3.Checked = false;
            DO4.Checked = false;
            DO5.Checked = false;
            DO6.Checked = false;
            DO7.Checked = false;

            DO0.Enabled = false;
            DO1.Enabled = false;
            DO2.Enabled = false;
            DO3.Enabled = false;
            DO4.Enabled = false;
            DO5.Enabled = false;
            DO6.Enabled = false;
            DO7.Enabled = false;

            SetS.Enabled = false;
            SetP.Enabled = false;
        }

        private void WD_Click(object sender, EventArgs e)
        {
            WDT.Enabled = WD.Checked;
        }

        private void btnUpdate_Click(object sender, EventArgs e)
        {
            BlockIOAPIr.SYS_SetWatchDogConfig(mHandle, WD.Checked, Convert.ToSingle(WDT.Text));
        }

        private void DO0_Click(object sender, EventArgs e)
        {
            BlockIO5068r.DIO_SetDO(mHandle, 0, DO0.Checked);
        }

        private void DO1_Click(object sender, EventArgs e)
        {
            BlockIO5068r.DIO_SetDO(mHandle, 1, DO1.Checked);
        }

        private void DO2_Click(object sender, EventArgs e)
        {
            BlockIO5068r.DIO_SetDO(mHandle, 2, DO2.Checked);
        }

        private void DO3_Click(object sender, EventArgs e)
        {
            BlockIO5068r.DIO_SetDO(mHandle, 3, DO3.Checked);
        }

        private void DO4_Click(object sender, EventArgs e)
        {
            BlockIO5068r.DIO_SetDO(mHandle, 4, DO4.Checked);
        }

        private void DO5_Click(object sender, EventArgs e)
        {
            BlockIO5068r.DIO_SetDO(mHandle, 5, DO5.Checked);
        }

        private void DO6_Click(object sender, EventArgs e)
        {
            BlockIO5068r.DIO_SetDO(mHandle, 6, DO6.Checked);
        }

        private void DO7_Click(object sender, EventArgs e)
        {
            BlockIO5068r.DIO_SetDO(mHandle, 7, DO7.Checked);
        }

        private void SetS_Click(object sender, EventArgs e)
        {
            BlockIO5068r.DIO_SetSafetyDO(mHandle);
        }

        private void SetP_Click(object sender, EventArgs e)
        {
            BlockIO5068r.DIO_SetPowerOnDO(mHandle);
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            byte[] dwDI = new byte[2];
            byte dwDO;
            BlockIO5068r.DIO_GetDIO(mHandle, dwDI, out dwDO);
            DI0.Checked = (dwDI[0] & (1 << 0)) > 0;
            DI1.Checked = (dwDI[0] & (1 << 1)) > 0;
            DI2.Checked = (dwDI[0] & (1 << 2)) > 0;
            DI3.Checked = (dwDI[0] & (1 << 3)) > 0;
            DI4.Checked = (dwDI[0] & (1 << 4)) > 0;
            DI5.Checked = (dwDI[0] & (1 << 5)) > 0;
            DI6.Checked = (dwDI[0] & (1 << 6)) > 0;
            DI7.Checked = (dwDI[0] & (1 << 7)) > 0;
            DI8.Checked = (dwDI[1] & (1 << 0)) > 0;
            DI9.Checked = (dwDI[1] & (1 << 1)) > 0;
            DI10.Checked = (dwDI[1] & (1 << 2)) > 0;
            DI11.Checked = (dwDI[1] & (1 << 3)) > 0;
            DI12.Checked = (dwDI[1] & (1 << 4)) > 0;
            DI13.Checked = (dwDI[1] & (1 << 5)) > 0;
            
            DO0.Checked = (dwDO & (1 << 0)) > 0;
            DO1.Checked = (dwDO & (1 << 1)) > 0;
            DO2.Checked = (dwDO & (1 << 2)) > 0;
            DO3.Checked = (dwDO & (1 << 3)) > 0;
            DO4.Checked = (dwDO & (1 << 4)) > 0;
            DO5.Checked = (dwDO & (1 << 5)) > 0;
            DO6.Checked = (dwDO & (1 << 6)) > 0;
            DO7.Checked = (dwDO & (1 << 7)) > 0;  
        }

        private void Form1_FormClosed(object sender, FormClosedEventArgs e)
        {
            if (mHandle.ToInt32() > 0) BlockIOAPIr.SYS_Release(mHandle);
        }
    }
}