#ifndef BLOCKIO5014_APIS_H
#define BLOCKIO5014_APIS_H

#include "CommDef.h"
#include "HandleDef.h"
#include "ErrorCodeDef.h"

#if !defined(_BIO_APIS_H_)
    #define FUNCEXPORTS  __declspec (dllimport)
#else
    #define FUNCEXPORTS  __declspec (dllexport)
#endif

#ifdef __cplusplus
extern "C"
{
#endif

	typedef struct tagI5014AlarmInfo
{
	BYTE  byAlarmStatus;	// bit 0
	BYTE  byAlarmMode;		// bit 1
	DWORD dwAlarmAction;	// bit 2
	
	BYTE  byMask;
	BYTE  byResult;

} I5014_ALARM_INFO;

// BLOCKIO5014: 4-CH Analog Inputs w/DO Module
FUNCEXPORTS DWORD WINAPI RTD_GetAI(HANDLE hSession, BYTE byChId, double *pdblAI);
// byStatus : xxxxxxxx  binary
//            7      0  channel
FUNCEXPORTS DWORD WINAPI RTD_GetChannelStatus(HANDLE hSession, BYTE *pbyStatus);
// byChId : 0 ~ 4 - single channel, 255 - All channels
FUNCEXPORTS DWORD WINAPI RTD_SetChannelStatus(HANDLE hSession, BYTE byChId, BYTE byStatus);

FUNCEXPORTS DWORD WINAPI RTD_GetAlarmInfo(HANDLE hSession, I5014_ALARM_INFO* pAlarmInfo);
FUNCEXPORTS DWORD WINAPI RTD_SetAlarmInfo(HANDLE hSession, I5014_ALARM_INFO* pAlarmInfo);

FUNCEXPORTS DWORD WINAPI RTD_SetAlarmLimits(HANDLE hSession, BYTE byChId, double dblHiVal, double dblLoVal, BYTE byLimitsMask);
FUNCEXPORTS DWORD WINAPI RTD_GetAlarmLimits(HANDLE hSession, BYTE byChId, double *pdblHiVal, double *pdblLoVal);

FUNCEXPORTS DWORD WINAPI RTD_SetSnmpTrapCount(HANDLE hSession, BYTE byCount);
FUNCEXPORTS DWORD WINAPI RTD_GetSnmpTrapCount(HANDLE hSession, BYTE *pbyCount);
FUNCEXPORTS DWORD WINAPI RTD_SetSnmpTrapIP(HANDLE hSession, BYTE byChId, LPCTSTR lpszIP);
FUNCEXPORTS DWORD WINAPI RTD_GetSnmpTrapIP(HANDLE hSession, BYTE byChId, LPTSTR lpszIP);
FUNCEXPORTS DWORD WINAPI RTD_ResetSnmpTrap(HANDLE hSession);

FUNCEXPORTS DWORD WINAPI RTD_GetInputRange(HANDLE hSession, BYTE *pbyIR);
FUNCEXPORTS DWORD WINAPI RTD_SetInputRange(HANDLE hSession, BYTE byIR);

#ifdef __cplusplus
}
#endif

#endif