#ifndef BLOCKIO5018_APIS_H
#define BLOCKIO5018_APIS_H

#include "CommDef.h"
#include "HandleDef.h"
#include "ErrorCodeDef.h"

#if !defined(_BIO_APIS_H_)
    #define FUNCEXPORTS  __declspec (dllimport)
#else
    #define FUNCEXPORTS  __declspec (dllexport)
#endif

#ifdef __cplusplus
extern "C"
{
#endif

FUNCEXPORTS DWORD WINAPI TC_GetCJCValue(HANDLE hSession, double *pdblVoltage);
FUNCEXPORTS DWORD WINAPI TC_SetCJCOffset(HANDLE hSession, double dbOffset);
FUNCEXPORTS DWORD WINAPI TC_CalibrateCJC(HANDLE hSession);

FUNCEXPORTS DWORD WINAPI TC_SetSnmpTrapCount(HANDLE hSession, BYTE byCount);
FUNCEXPORTS DWORD WINAPI TC_GetSnmpTrapCount(HANDLE hSession, BYTE *pbyCount);
FUNCEXPORTS DWORD WINAPI TC_SetSnmpTrapIP(HANDLE hSession, BYTE byChId, LPCTSTR lpszIP);
FUNCEXPORTS DWORD WINAPI TC_GetSnmpTrapIP(HANDLE hSession, BYTE byChId, LPTSTR lpszIP);
FUNCEXPORTS DWORD WINAPI TC_ResetSnmpTrap(HANDLE hSession);
FUNCEXPORTS DWORD WINAPI TC_GetInputRange(HANDLE hSession, BYTE *pbyIR);
FUNCEXPORTS DWORD WINAPI TC_SetInputRange(HANDLE hSession, BYTE byIR);
FUNCEXPORTS DWORD WINAPI TC_GetAI(HANDLE hSession, BYTE byChId, double *pdblAI);
// byStatus : xxxxxxxx  binary
//            7      0  channel
FUNCEXPORTS DWORD WINAPI TC_GetChannelStatus(HANDLE hSession, BYTE *pbyStatus);
// byChId : 0 ~ 4 - single channel, 255 - All channels
FUNCEXPORTS DWORD WINAPI TC_SetChannelStatus(HANDLE hSession, BYTE byChId, BYTE byStatus);

#ifdef __cplusplus
}
#endif

#endif